	// DOM 元素对象模板
	var $ = function(id){
		this.id = id;
		this.obj = document.getElementById(this.id);
	}
	$.prototype = {
		// 获取元素的某项 CSS
		getClass: function(name){
			// IE8及以下版本
			if(this.obj.currentStyle) {
				return this.obj.currentStyle[name];
			}
			// Firefox, Chrome, IE9+
			else {
				var style = document.defaultView.getComputedStyle(this.obj, null);
				return style[name];
			}
		},
		// 以元素高宽生成动画对象
		cal: function(speed, mode, fn){
			// 创建动画对象
			this.theTransform = new Transform(this.obj, speed, mode, fn);
			this.theTransform.theWidth = this.getClass('width').replace('px','');
			this.theTransform.theHeight = this.getClass('height').replace('px','');
			// 按长宽比例计算单位时间内元素宽带减少值
			this.theTransform.widthChange = this.theTransform.heightChange*(this.theTransform.theWidth / this.theTransform.theHeight);
		},
		// 隐藏元素
		hide: function(speed, mode, fn){
			this.cal(speed, mode, fn);
			this.theTransform.hide(this.theTransform.theWidth, this.theTransform.theHeight);
		},
		// 显示元素
		show: function(speed, mode, fn){
			this.cal(speed, mode, fn);
			this.theTransform.show(0, 0);
		}
	}
	// 动画对象模板
	var Transform = function(obj, speed, mode, fn){
		this.obj = obj;
		this.speed = speed; // 动画速度
		this.mode = mode;	// 动画形式
		this.heightChange = 10;
		this.fn = fn;
		if( speed === 'fast')
			this.speed = 10;
		else if( speed === 'normal' )
			this.speed = 20;
		else if( speed === 'slow' )
			this.speed = 30;
	}
	Transform.prototype = {
		// 处理隐藏
		hide: function( width, height ){
			var self = this;
			if ( !this.speed ) {
				this.obj.style.display = 'none';
				return;
			}
			width = width - this.widthChange > 0 ? width - this.widthChange : 0;
			height = height - this.heightChange > 0 ? width - this.heightChange : 0;	
			// 
			if( width !== 0 || height !== 0 ) {
				// 判断采用何种动画形式
				if( this.mode === 'zoom' ) this.obj.style.width = width + 'px';
				this.obj.style.height = height + 'px';
				// 递归调用自身
				setTimeout(function(){self.hide(width,height)},this.speed);
			} else {
				// 完成后清除所有 style 属性
				this.obj.style.cssText = "";
				// 设置 display: none
				this.obj.style.display = 'none';
				if(this.fn) this.fn.call(this.obj);
			}
		},
		// 处理显示
		show: function(width, height){
			// 判断元素是否为 block，若否，则设置为 block
			if( this.obj.style.display !== 'block' ){
				// 判断采用何种动画形式
				if( this.mode === 'zoom' ) this.obj.style.width = 0 + 'px';
				this.obj.style.height = 0 + 'px';
				this.obj.style.display = 'block';
				this.showIt( width, height );
			}
		},
		showIt: function( width, height ){
			var self = this;
			if ( !this.speed ) {	
				this.obj.style.display = 'block';
				return;
			}
			width = width + this.widthChange < this.theWidth ? width + this.widthChange : this.theWidth;
			height = height + this.heightChange < this.theHeight ? height + this.heightChange : this.theHeight;
			// 判断元素是否恢复到 CSS 中设定的高宽
			if( width !== this.theWidth || height !== this.theHeight ) {
				if( this.mode === 'zoom' ) this.obj.style.width = width + 'px';
				this.obj.style.height = height + 'px';
				setTimeout(function(){self.showIt(width,height)},this.speed);
			} else {
				// 完成后清除所有 style 属性
				this.obj.style.cssText = "";
				// 设置 display: block
				this.obj.style.display = 'block';
				if(this.fn) this.fn.call(this.obj);
			}
		}
	}